<%--

  Copyright (c) 20010-2011, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.

  WSO2 Inc. licenses this file to you under the Apache License,
  Version 2.0 (the "License"); you may not use this file except
  in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an
  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, either express or implied.  See the License for the
  specific language governing permissions and limitations
  under the License.

--%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.cloud.csg.agent.ui.CSGAgentAdminClient" %>
<%@ page import="org.apache.axis2.AxisFault" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="org.wso2.carbon.cloud.csg.agent.stub.types.carbon.CSGServerBean" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>


<%
    boolean isEditMode = false;
    String host = "", port = "", userName = "", passWord = "", domain = "";
    String serverName = request.getParameter("serverName");
    if(request.getParameter("mode") != null && request.getParameter("mode").equals("edit")){
        session.setAttribute("mode", "edit");
        isEditMode = true;
    }
    try {
        if (serverName != null) {
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext =
                    (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            CSGAgentAdminClient csgAdminClient = new CSGAgentAdminClient(
                    cookie, backendServerURL, configContext, request.getLocale());

            CSGServerBean bean = csgAdminClient.getCSGServer(serverName);
            host = bean.getHost();
            port = bean.getPort();
            domain = bean.getDomainName();
            userName = bean.getUserName();
            passWord = bean.getPassWord();
        } else {
            serverName = "";
        }
    } catch (AxisFault axisFault) {
        CarbonUIMessage.sendCarbonUIMessage("Cloud not retrive the CSG server" + serverName + "info",
                CarbonUIMessage.ERROR, request);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>

<%
        return;
    }
%>

<fmt:bundle basename="org.wso2.carbon.cloud.csg.agent.ui.i18n.Resources">

<script type="text/javascript">
    function cancel(){
        location.href = 'index.jsp';
    }

    function saveChanges(){
        document.csgServerForm.action = 'save-csg-server.jsp';
        if(doValidation()){
            document.csgServerForm.submit();
        }
    }

    function doValidation(){
        var serverName = document.getElementById('csg_server_name_id').value;
        if(isEmpty(serverName)){
            CARBON.showWarningDialog("<fmt:message key="csg.error.empty.servername"/>");
            return false;
        }

        var hostName = document.getElementById('csg_host_name_id').value;
        if(isEmpty(hostName)){
            CARBON.showWarningDialog("<fmt:message key="csg.error.empty.hostname"/>");
            return false;
        }

        var domainName = document.getElementById('csg_domain_name_id').value;
        if (isEmpty(domainName)) {
            CARBON.showWarningDialog("<fmt:message key="csg.error.empty.domain"/>");
            return false;
        }

        if (!isValidDomain(domainName)) {
            return false;
        }

        var csgHostPort = document.getElementById('csg_host_port_id').value;
        if(isEmpty(csgHostPort)){
            CARBON.showWarningDialog("<fmt:message key="csg.error.empty.port"/>");
            return false;
        }
        if(isNaN(csgHostPort)){
            CARBON.showWarningDialog("<fmt:message key="csg.error.not.a.number"/>");
            return false;
        }

        var userName = document.getElementById('csg_user_name_id').value;
        if(isEmpty(userName)){
            CARBON.showWarningDialog("<fmt:message key="csg.error.empty.username"/>");
            return false;
        }

        var password = document.getElementById('csg_user_password_id').value;
        if(isEmpty(password)){
            CARBON.showWarningDialog("<fmt:message key="csg.error.empty.password"/>");
            return false;
        }

        return true;
    }

    function isEmpty(fieldName){
        return fieldName == null || fieldName == undefined || fieldName == 'undefined' || fieldName.length == 0;
    }

    function isValidDomain(nname) {

        var val = true;
        var dot = nname.lastIndexOf(".");
        var dname = nname.substring(0, dot);
        var ext = nname.substring(dot, nname.length);
        //alert(ext);

        if (ext.indexOf("-trial") >= 0 || ext.indexOf("-unverified") >= 0) {
            // we are not allowing to create a domain with -trial or -unverified is in the extension
            CARBON.showWarningDialog("<fmt:message key="csg.invalid.domain"/>");
            return false;
        }

        if (ext.indexOf("/") >= 0 || ext.indexOf("\\") >= 0) {
            CARBON.showWarningDialog("<fmt:message key="csg.invalid.encoding"/>");
            return false;
        }

        if (dot > 1 && dot < 57) {

            if (!val) {
                CARBON.showWarningDialog("<fmt:message key="csg.invalid.extension"/>");
                return false;
            }
            else {
                for (var j = 0; j < dname.length; j++) {
                    var dh = dname.charAt(j);
                    var hh = dh.charCodeAt(0);
                    if ((hh > 47 && hh < 59) || (hh > 64 && hh < 91) || (hh > 96 && hh < 123) || hh == 45 || hh == 46) {
                        if ((j == 0 || j == dname.length - 1) && hh == 45) {
                            CARBON.showWarningDialog("<fmt:message key="csg.invalid.name"/>");;
                            return false;
                        }
                    }
                    else {
                        CARBON.showWarningDialog("<fmt:message key="csg.has.special.characters"/>");
                        return false;
                    }
                }
            }
        }
        else {
            CARBON.showWarningDialog("<fmt:message key="csg.long.domain"/>");;
            return false;
        }
        return true;
    }

</script>

<carbon:breadcrumb
            label="csg.add.server"
            resourceBundle="org.wso2.carbon.cloud.csg.agent.ui.i18n.Resources"
            topPage="true"
            request="<%=request%>"/>

    <div id="middle">
        <h2>
            <%
                if (isEditMode) {
            %>
            <fmt:message key="csg.edit.server"/>
        <%
        } else {
        %>
            <fmt:message key="csg.add.server"/>
        <%
            }
        %>
        </h2>        

        <div id="workArea">
            <form method="post" action="save-csg-server.jsp" name="csgServerForm">
                <table class="styledLeft" id="csgServerInfoTableId" width="60%">
                    <thead>
                        <tr>
                            <th><fmt:message key="csg.server.info"/></th>
                        </tr>
                    </thead>
                    <tr>
                        <td class="formRaw">
                            <table class="normal">
                                <tr>
                                    <td width="5%" style="white-space:nowrap;">
                                        <fmt:message key="csg.server.name"/> <span class="required">*</span>
                                    </td>
                                    <td align="left" colspan="2">
                                        <label for="csg_server_name_id"></label>
                                        <input type="text" name="csg_server_name_id" id="csg_server_name_id" value="<%=serverName%>"
                                                 <%=isEditMode?"disabled=\"disabled\"" : ""%> onkeypress="return validateText(event);"/>
                                        <%
                                            if (isEditMode) {
                                        %>
                                         <input type="hidden" name="csg_server_name_id_hidden" id="csg_server_name_id_hidden" value="<%=serverName%>"/>
                                        <%
                                            }
                                        %>
                                    </td>
                                </tr>
                                <tr>
                                    <td width="5%" style="white-space:nowrap;">
                                        <fmt:message key="csg.host.name"/> <span class="required">*</span>
                                    </td>
                                    <td align="left" colspan="2">
                                        <label for="csg_host_name_id"></label><input type="text" name="csg_host_name_id" id="csg_host_name_id" value="<%=host%>" onkeypress="return validateText(event);"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td width="5%" style="white-space:nowrap;">
                                        <fmt:message key="csg.host.port"/> <span class="required">*</span>
                                    </td>
                                    <td align="left" colspan="2">
                                        <label for="csg_host_port_id"></label><input type="text" name="csg_host_port_id" id="csg_host_port_id" value="<%=port%>" onkeypress="return validateText(event);"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td width="5%" style="white-space:nowrap;">
                                        <fmt:message key="csg.domain.name"/> <span class="required">*</span>
                                    </td>
                                    <td align="left" colspan="2">
                                        <label for="csg_domain_name_id"></label><input type="text" name="csg_domain_name_id" id="csg_domain_name_id" value="<%=domain%>" onkeypress="return validateText(event);"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td width="5%" style="white-space:nowrap;">
                                        <fmt:message key="csg.user.name"/> <span class="required">*</span>
                                    </td>
                                    <td align="left" colspan="2">
                                        <label for="csg_user_name_id"></label><input type="text" name="csg_user_name_id" id="csg_user_name_id" value="<%=userName%>" onkeypress="return validateText(event);"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td width="5%" style="white-space:nowrap;">
                                        <fmt:message key="csg.user.password"/> <span class="required">*</span>
                                    </td>
                                    <td align="left" colspan="2">
                                        <label for="csg_user_password_id"></label><input type="password" name="csg_user_password_id" id="csg_user_password_id" value="<%=passWord%>" onkeypress="return validateText(event);"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow">
                            <label>
                                <input type="button" class="button" value="<fmt:message key="save"/>" onclick="saveChanges();"/>
                            </label>
                            <label>
                                <input type="button" class="button" value="<fmt:message key="cancel"/>" onclick="cancel();"/>
                            </label>
                        </td>
                    </tr>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>