<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.cloud.csg.agent.ui.CSGAgentAdminClient" %>
<%@ page import="org.apache.axis2.AxisFault" %>
<%@ page import="org.wso2.carbon.cloud.csg.agent.stub.types.carbon.CSGServerBean" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<%--<script type="text/javascript" src="../resources/js/resource_util.js"></script>--%>

<%
    boolean isPublished = false;
    String publishedTRStyle = "display:none";
    String unPublishedTRStyle = "";
    String serverName = null;

    CSGServerBean[] serverBeans = null;
    String serviceName = request.getParameter("serviceName");

    try {
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        CSGAgentAdminClient csgAdminClient = new CSGAgentAdminClient(
                    cookie, backendServerURL, configContext, request.getLocale());
        if (csgAdminClient.getCSGServerList() != null && csgAdminClient.getCSGServerList()[0] != null) {
            serverBeans = new CSGServerBean[csgAdminClient.getCSGServerList().length];
            serverBeans = csgAdminClient.getCSGServerList();
            if (serviceName != null) {
                isPublished = csgAdminClient.isservicePublished(serviceName);
                publishedTRStyle = !isPublished ? "" : "display:none";
                unPublishedTRStyle = isPublished ? "" : "display:none";
            }
        } else {
            // no servers defined prompt the user to add servers
            publishedTRStyle = "";
            unPublishedTRStyle = "display:none";
        }
    } catch (AxisFault axisFault) {
        CarbonUIMessage.sendCarbonUIMessage("Cloud not retrieve the server list," + axisFault.getMessage(),
                CarbonUIMessage.ERROR, request);

%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>

<%
        return;
    }
%>

<fmt:bundle basename="org.wso2.carbon.cloud.csg.agent.ui.i18n.Resources">
<tr><td>&nbsp;</td></tr>
<table class="styledLeft" id="csgTable" width="100%" style="margin-left: 0px;">
<thead>
<tr>
    <th colspan="2" align="left"><fmt:message key="csg.configuration"/></th>
</tr>
</thead>
<tr>
    <td id="publishToCSG<%=serviceName%>" style="<%=publishedTRStyle%>" colspan="2">
        <div id="rotating_indicator_id" style="display:none;position: absolute;margin-top:35px;margin-left:-5px;padding-left:20px;background:transparent url(../csg/images/loading-small.gif) no-repeat left top;"><fmt:message key="csg.publishing"/></div>
        <span class="icon-text" style="background-image: url(../csg/images/publish.png);"><fmt:message key="csg.publish"/></span>
        &nbsp;&nbsp;
        <%
            if(serverBeans != null) {
         %>
        <label for="publish_to_csg_server_selector"></label>
        <select id="publish_to_csg_server_selector" style="margin-top: 2px ! important;" onchange="changeCloudService('<%=serviceName%>','publish');return false;">
                <option value="choose-server" id="default-value" selected="true"><fmt:message key="csg.select.server"/> </option>
         <%
              for (CSGServerBean serverBean : serverBeans) {
              %>
                  <option value="<%=serverBean.getName()%>"><%=serverBean.getName()%></option>
              <%
              }
         %>
            </select>
         <%
          } else {
          %>
            <a href="#" style="line-height:24px" onclick="addNewCSGServer();return false;"><fmt:message key="csg.add.short"/></a>
          <%
          }
         %>
    </td>
    <td id="unPublishFromCSG<%=serviceName%>" style="<%=unPublishedTRStyle%>" colspan="2">
        <div id="rotating_indicator_id2" style="display:none;position: absolute;margin-top:35px;margin-left:-5px;padding-left:20px;background:transparent url(../csg/images/loading-small.gif) no-repeat left top;"><fmt:message key="csg.unpublishing"/></div>
        <a href="#" class="icon-link-nofloat" style="background-image: url(../csg/images/publish.png);" onclick="changeCloudService('<%=serviceName%>','unpublish');return false;"><fmt:message key="csg.unpublish"/></a>
    </td>
</tr>
</table>

<%--<script type="text/javascript" src="../carbon/global-params.js"></script>--%>
<script type="text/javascript">

    jQuery(document).ready(function() {
        showHideOptionsOnLoad();
    });

    function addNewCSGServer(){
        location.href = '../csg/add-edit-csg-server.jsp';
    }

    function showHideOptionsOnLoad() {
        if (<%=isPublished%>) {
            hideElem('publishToCSG' + '<%=serviceName%>');
            showElem('unPublishFromCSG' + '<%=serviceName%>');
        } else {
            hideElem('unPublishFromCSG' + '<%=serviceName%>');
            showElem('publishToCSG' + '<%=serviceName%>');
        }
    }

    function showElem(id) {
        document.getElementById(id).style.display = "";
    }

    function hideElem(id) {
        document.getElementById(id).style.display = "none";
    }

    function changeCloudService(){
        var mode = arguments[1];
        if(mode == 'publish'){
            var serverName = document.getElementById('publish_to_csg_server_selector').value;
            if (serverName == 'choose-server') {
                CARBON.showWarningDialog("<fmt:message key="csg.invalid.selection"/>");
                return;
            }
            document.getElementById('rotating_indicator_id').style.display = "";
            jQuery.get("../csg/publish-service_ajaxprocessor.jsp", {'serviceName' : arguments[0],'serverName':serverName , 'mode' : 'publish'},
                    function(data,status) {
                        handleCallBack(data,status,"unPublishFromCSG", "publishToCSG",'publish');
                    });
        } else if(mode == 'unpublish'){
            document.getElementById('rotating_indicator_id2').style.display = "";
            jQuery.get("../csg/publish-service_ajaxprocessor.jsp", {'serviceName' : arguments[0],'mode' : 'unpublish'},
                    function(data,status) {
                        handleCallBack(data,status,"publishToCSG", "unPublishFromCSG",'unpublish');
                    });
        }
    }

    function handleCallBack(data, status, show, hide, mode) {
        if (mode == 'publish') {
            document.getElementById('rotating_indicator_id').style.display = "none";
        } else if (mode == 'unpublish') {
            document.getElementById('rotating_indicator_id2').style.display = "none";
        }
        if (data.replace(/^\s+|\s+$/g, '') != 'successful') {
            document.getElementById('publish_to_csg_server_selector').selectedIndex = 0;
            if (mode == 'publish') {
                CARBON.showErrorDialog('<fmt:message key="could.not.change.publish.service"/>');
            } else {
                CARBON.showErrorDialog('<fmt:message key="could.not.change.unpublish.service"/>');
            }
        } else {
            if (show != null && hide != null) {
                showHideIcon(show, hide);
            }
            if (mode == 'publish') {
                CARBON.showInfoDialog('<fmt:message key="service.published.sucessfully"/>');
            } else if (mode == 'unpublish') {
                document.getElementById('publish_to_csg_server_selector').selectedIndex = 0;
                CARBON.showInfoDialog('<fmt:message key="service.unpublished.sucessfully"/>');
            }
        }
    }

    function showHideIcon(show, hide) {
        hideElem(hide + '<%=serviceName%>');
        showElem(show + '<%=serviceName%>');
    }
</script>
    
</fmt:bundle>